package com.yaohun.consumereward.data;

import org.bukkit.Bukkit;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.entity.Player;

import java.util.List;

public class RewardData {

    private String rewardKey;
    private int slot;
    private int needConsume;
    private int backpackSlot;
    private String itemNbt;
    private List<String> rewardLore;
    private List<String> commandList;

    public RewardData(String rewardKey, ConfigurationSection section){
        this.rewardKey = rewardKey;
        this.slot = section.getInt(rewardKey+".slot");
        this.needConsume = section.getInt(rewardKey+".needConsume");
        this.backpackSlot = section.getInt(rewardKey+".backpackSlot");
        this.itemNbt = section.getString(rewardKey+".itemNbt");
        this.rewardLore = section.getStringList(rewardKey+".rewardLore");
        this.commandList = section.getStringList(rewardKey+".commandList");
    }

    public String getRewardKey() {
        return rewardKey;
    }
    public int getSlot() {
        return slot;
    }
    public int getNeedConsume() {
        return needConsume;
    }
    public int getBackpackSlot() {
        return backpackSlot;
    }
    public String getItemNbt() {
        return itemNbt;
    }
    public List<String> getRewardLore() {
        return rewardLore;
    }
    public void carryOutReward(Player player){
        String playerName = player.getName();
        // 遍历所有命令并执行
        for(String command : commandList) {
            if (command.contains("msg:")) {
                // 如果是消息命令，去掉前缀后发送消息
                player.sendMessage(command.replace("msg:", "").replace("&", "§"));
                continue;
            }
            // 替换命令中的玩家名称占位符%p%为真实名称
            command = command.replace("%p%", playerName);
            command = command.replace("%player%", playerName);
            // 执行命令
            Bukkit.dispatchCommand(Bukkit.getConsoleSender(),command);
        }
        // 记录日志
        Bukkit.getLogger().info("[消费奖励 - 发放] " + player.getName() + " 已执行奖励命令: " + rewardKey);
    }
}
