package com.yaohun.consumereward.gui;

import com.yaohun.aurechargedata.api.ConsumeAPI;
import com.yaohun.aurechargedata.util.TimeType;
import com.yaohun.consumereward.ConsumeReward;
import com.yaohun.consumereward.config.Config;
import com.yaohun.consumereward.data.PlayerData;
import com.yaohun.consumereward.data.RewardData;
import com.yaohun.consumereward.manage.PlayerManager;
import com.yaohun.consumereward.util.MessageUtil;
import com.yaohun.consumereward.util.StackUtil;
import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonPlugin.data.NbtItem;
import org.bukkit.Bukkit;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

public class RewardGui implements Listener {

    public static void OpenGui(Player player){
        String playerName = player.getName();
        Inventory inv = Bukkit.createInventory(null,54, Config.langData.getMessage("invTitle"));
        for (int i = 0;i<9;i++){ inv.setItem(i, DemonAPI.glass(DemonAPI.getRandomInt(7,1),"§r")); }
        inv.setItem(4, StackUtil.getDataInfo(playerName));
        PlayerManager playerManager = ConsumeReward.getPlayerManager();
        PlayerData playerData = playerManager.getPlayerData(playerName);
        for (RewardData rewardData : Config.getRewardDataList()){
            inv.setItem(rewardData.getSlot(), StackUtil.getRewardGiftBox(playerData, rewardData));
        }
        player.openInventory(inv);
    }

    @EventHandler
    public void onClick(InventoryClickEvent e){
        int rawSlot = e.getRawSlot();
        Player player = (Player) e.getWhoClicked();
        String playerName = player.getName();
        if(e.getView().getTitle().equalsIgnoreCase(Config.langData.getMessage("invTitle"))) {
            e.setCancelled(true);
            if (rawSlot >= 0 && rawSlot < e.getInventory().getSize()) {
                ItemStack stack = e.getCurrentItem();
                if (DemonAPI.itemIsNull(stack) || DemonAPI.itemIsLore(stack)) {
                    return;
                }
                NbtItem nbtItem = new NbtItem(stack);
                if (nbtItem.hasKey("rewardKey")) {
                    String value = nbtItem.getString("rewardKey");
                    RewardData rewardData = Config.getRewardData(value);
                    if (rewardData == null) {
                        return;
                    }
                    int backpackSlot = rewardData.getBackpackSlot();
                    if (!DemonAPI.hasEmptyInventorySlots(player, backpackSlot)) {
                        MessageUtil.sendMessageKey(player, "notEnoughInventorySlots", Sound.ENTITY_VILLAGER_NO);
                        return;
                    }
                    int needConsume = rewardData.getNeedConsume();
                    int consumeValue = ConsumeAPI.getConsumeData(playerName, TimeType.ANNUAL);
                    if (needConsume > consumeValue) {
                        String message = Config.langData.getMessage("notEnoughConsume");
                        int newConsume = needConsume - consumeValue;
                        message = message.replace("{needConsume}", String.valueOf(newConsume));
                        MessageUtil.sendMessage(player, message, Sound.ENTITY_VILLAGER_NO);
                        return;
                    }
                    PlayerManager playerManager = ConsumeReward.getPlayerManager();
                    PlayerData playerData = playerManager.getPlayerData(playerName);
                    if (playerData.isReceive(value)) {
                        MessageUtil.sendMessageKey(player, "alreadyReceived", Sound.ENTITY_VILLAGER_NO);
                        return;
                    }
                    player.closeInventory();
                    playerData.addRewardReceive(value);
                    playerData.savePlayerData();
                    rewardData.carryOutReward(player);
                    String message = Config.langData.getMessage("announcement");
                    message = message.replace("{name}", playerName);
                    message = message.replace("{itemName}", DemonAPI.getItemName(stack));
                    Bukkit.broadcastMessage(message);
                    MessageUtil.sendMessageKey(player, "receivedSuccessfully", Sound.ENTITY_PLAYER_LEVELUP);
                }
            }
        }
    }
}
