package com.yaohun.consumereward.util;

import com.yaohun.aurechargedata.api.ConsumeAPI;
import com.yaohun.aurechargedata.util.TimeType;
import com.yaohun.consumereward.config.Config;
import com.yaohun.consumereward.data.PlayerData;
import com.yaohun.consumereward.data.RewardData;
import me.Demon.DemonPlugin.data.NbtItem;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class StackUtil {

    public static ItemStack getDataInfo(String playerName){
        ItemStack stack = Config.getItemStack("dataInfo");
        ItemMeta meta = stack.getItemMeta();
        List<String> lore = meta.getLore();
        for (int i = 0; i < lore.size(); i++){
            String line = lore.get(i);
            if(line.contains("{name}")){
                lore.set(i, line.replace("{name}", playerName));
                continue;
            }
            if(line.contains("{consume}")){
                int consumeValue = ConsumeAPI.getConsumeData(playerName, TimeType.ANNUAL);
                lore.set(i, line.replace("{consume}", String.valueOf(consumeValue)));
            }
        }
        meta.setLore(lore);
        stack.setItemMeta(meta);
        return stack;
    }

    public static ItemStack getRewardGiftBox(PlayerData playerData, RewardData rewardData){
        String rewardKey = rewardData.getRewardKey();
        ItemStack stack = Config.getItemStack("rewardGiftBox");
        ItemMeta meta = stack.getItemMeta();
        List<String> newLore = new ArrayList<>();
        for (String line : meta.getLore()){
            if(line.contains("{stats}")){
                if(playerData.isReceive(rewardKey)){
                    newLore.add(line.replace("{stats}", Config.langData.getMessage("statsOK")));
                } else {
                    newLore.add(line.replace("{stats}", Config.langData.getMessage("statsNO")));
                }
            } else if(line.contains("{rewardLore}")){
                newLore.addAll(rewardData.getRewardLore());
            } else {
                newLore.add(line);
            }
        }
        meta.setLore(newLore);
        stack.setItemMeta(meta);
        NbtItem nbtItem = new NbtItem(stack);
        nbtItem.setString("rewardKey", rewardKey);
        return nbtItem.getItem();
    }
}
